.nolist
include \masm32\include\masm32rt.inc
useMovup=1	; lddqu faster than movdqu on P4 if data are in cache; movups does the same but is one byte shorter
usexps=0	; movhps xmm0, [esi+8]/movlps xmm0, [esi]: a lot slower on P4, 5000+ cycles instead of 3500 for the 5000 byte string

.686
.xmm
include \masm32\macros\timers.asm			; get them from the [url=http://www.masm32.com/board/index.php?topic=770.0]Masm32 Laboratory[/url]
LOOP_COUNT	= 10000

StrCmpSSE_ci	PROTO: DWORD, :DWORD
StrCmpSSE	PROTO: DWORD, :DWORD

; Usage variants (they all produce the same code):
;	ldq xmm0, oword ptr [esi]	; full version, like lddqu xmm0, oword ptr [esi]
;	ldq xmm0, [esi]	; short version, like movupd xmm1, [edi]
;	ldq xmm0, esi	; lazy version
ldq MACRO xreg, reg	; substitute for SSE3 lddqu xmm0, [esi] with ml useMovup
LOCAL isx, isr, isb
  isb INSTR <reg>, <[>
  if isb
	isr INSTR <eax/ecx/edx/ebx/eSp/ebp/esi/edi>, @SubStr(<reg>, isb+1, 3)
  else
	isr INSTR <eax/ecx/edx/ebx/eSp/ebp/esi/edi>, <reg>
  endif
  if isr
	isx INSTR <xmm0xmm1xmm2xmm3xmm4xmm5xmm6xmm7>, <xreg>
	if isx
		isx=(isx-1)*2
		db 0F2h, 0Fh, 0F0h
		db isx+(isr-1)/4
	else
		echo <xreg> is not a valid xmm register
		.err
	endif
  else
	echo <reg> is not a valid register
	.err
  endif
ENDM

.data

ALIGN 16
Dummy3	    db 1	; activate to misalign
Src3        db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
   REPEAT 48
	        db "This is a string, 100 characters long, that serves for a variety of purposes, such as testing algos?"
   ENDM
	        db "This is a string, 99 characters long, that serves for a variety of purposes, such as testing algos"
MatchChar   db "!"
MatchNull   db 0,'@',0,0,0,0,0,0,0,0,0,0,0,0,0,0    ;   The @ is a false match beyond the null.


ALIGN 16
Src4    db 0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0  ;   XMM Null check.
Src5    db "                "               ;   For XMM char check.
Src6    db "!",0,0,0                        ;   For crt_strchr.
Src7    db "@",0,0,0                        ;   For crt_strchr.

.data?

.code
start:
	push 1
	call ShowCpu	; prints the brand string and returns SSE level@
	print "Find character in string: long string "
	print str$(5000)
    print " bytes.", 13, 10

	REPEAT 2

	invoke Sleep, 200

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src3
		mov edi, DWORD PTR Src6
        call dostrchr
ifdef DEBUGHALT
cmp eax,offset MatchChar
jnz Bad1
endif
    counter_end

	print str$(eax), 9, "cycles for crt_strchr, match long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		lea esi, Src3
		mov edi, DWORD PTR Src7
        call dostrchr
ifdef DEBUGHALT
cmp eax,0
jnz Bad2
endif
    counter_end

	print str$(eax), 9, "cycles for crt_strchr, no match long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src3
        mov  bl,'!'
		push ebx
		call KRBOld
ifdef DEBUGHALT
cmp eax,offset MatchChar
jnz Bad3
endif
    counter_end

	print str$(eax), 9, "cycles for KRBOld, match long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src3
        mov  bl,'!'
		push ebx
		call KRBNew
ifdef DEBUGHALT
cmp eax,offset MatchChar
jnz Bad4
endif
    counter_end

	print str$(eax), 9, "cycles for KRBNew, match long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src3
        mov  bl,'!'
		push ebx
		call KRBNew2
ifdef DEBUGHALT
cmp eax,offset MatchChar
jnz Bad5
endif
    counter_end

	print str$(eax), 9, "cycles for KRBNew2, match long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src3
        mov  bl,'!'
		push ebx
		call KRBNew3
ifdef DEBUGHALT
cmp eax,offset MatchChar
jnz Bad6
endif
    counter_end

	print str$(eax), 9, "cycles for KRBNew3, match long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src3
        xor  bl,bl
		push ebx
		call KRBNew3
ifdef DEBUGHALT
cmp eax,offset MatchNull
jnz Bad7
endif
    counter_end

	print str$(eax), 9, "cycles for KRBNew3, match null in long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src3
        mov  bl,'@'
		push ebx
		call KRBOld
ifdef DEBUGHALT
cmp eax,0
jnz Bad8
endif
    counter_end

	print str$(eax), 9, "cycles for KRBOld, no match long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src3
        mov  bl,'@'
		push ebx
		call KRBNew
;ifdef DEBUGHALT        ;   This one will fail - find the @ beyond the null
;cmp eax,0              ;   Don't check validity
;jnz Bad9
;endif
    counter_end

	print str$(eax), 9, "cycles for KRBNew, no match long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src3
        mov  bl,'@'
		push ebx
		call KRBNew2
ifdef DEBUGHALT
cmp eax,0
jnz Bad9
endif
    counter_end

	print str$(eax), 9, "cycles for KRBNew2, no match long string", 13, 10

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS	; LONG SOURCE
		push offset Src3
        mov  bl,'@'
		push ebx
		call KRBNew3
ifdef DEBUGHALT
cmp eax,0
jnz Bad10
endif
    counter_end

	print str$(eax), 9, "cycles for KRBNew3, no match long string", 13, 10

	ENDM

	print "Codesizes:", 13, 10
	print "dostrchr:", 9
	mov eax, dostrchr_endp
	sub eax, dostrchr
	print str$(eax), 13, 10
	print "KRBOld:", 9
	mov eax, KRBOld_endp
	sub eax, KRBOld
	print str$(eax), 13, 10
	print "KRBNew:", 9
	mov eax, KRBNew_endp
	sub eax, KRBNew
	print str$(eax), 13, 10
	print "KRBNew2:", 9
	mov eax, KRBNew2_endp
	sub eax, KRBNew2
	print str$(eax), 13, 10
	print "KRBNew3:", 9
	mov eax, KRBNew3_endp
	sub eax, KRBNew3
	print str$(eax), 13, 10
	inkey "--- ok ---"
	exit

ifdef DEBUGHALT
Bad1:int 3
Bad2:int 3
Bad3:int 3
Bad4:int 3
Bad5:int 3
Bad6:int 3
Bad7:int 3
Bad8:int 3
Bad9:int 3
Bad10:int 3
endif

push 1
call ShowCpu
ShowCpu proc		; mode:DWORD
COMMENT @ Usage: 
  push 0, call ShowCpu	; simple, no printing, just returns SSE level
  push 1, call ShowCpu	; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

dostrchr proc
		invoke crt_strchr, esi, edi
        ret
dostrchr endp
dostrchr_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

KRBOld proc
        pop    ecx
        pop    ebx
        pop    eax
        push   ecx
ALIGN   16
ScanChar:
        cmp    BYTE PTR [eax],bl            ;   The expected character?
        jz     ScanEnd                      ;   Yes.
        test   BYTE PTR [eax],0FFh          ;   End of string?
        lea    eax,[eax+1]                  ;   Increment the pointer to the next character.
        jnz    ScanChar                     ;   No, not done.
        xor    eax,eax
ScanEnd:
	    ret                                 ;   Return match pointer or null.
KRBOld endp
KRBOld_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

KRBNew proc
        pop    ecx
        pop    ebx
        pop    eax
        push   ecx
        mov    bh,bl                        ;   Build 16 copies of the search character.
        mov    cx,bx
        shl    ecx,16
        or     cx,bx
        mov    ebx,OFFSET Src5
        mov    [ebx],ecx
        mov    [ebx+4],ecx
        mov    [ebx+8],ecx
        mov    [ebx+12],ecx
        movdqa xmm1,[ebx]                   ;   16 copies of the search character.
        movdqa xmm2,OWORD PTR Src4          ;   16 nulls.
ScanChar:
        movdqu xmm0,[eax]                   ;   The last 16 BYTES of the buffer will be reserved so
                                            ;    that this MOV will not fail on a short last record.
        movdqa xmm3,xmm0                    ;   Copy.
        pcmpeqb xmm0,xmm1                   ;   1's replace xmm0 characters that match xmm1 characters.
        pmovmskb ecx,xmm0                   ;   Extract comparison bits - 1's for characters that matched.
        test   ecx,0FFFFh                   ;   Any character match?
        jnz    ScanEnd                      ;   Yes.
        pcmpeqb xmm3,xmm2                   ;   1's replace xmm0 characters that match xmm2 characters.
        pmovmskb ecx,xmm3                   ;   Extract comparison bits - 1's for characters that matched.
        test   ecx,0FFFFh                   ;   Any character a null?
        lea    eax,[eax+16]                 ;   Point to next 16 bytes.
        jz     ScanChar                     ;   No, null not found yet.
        xor    eax,eax                      ;   Set the return for no match.
        jmp    NoMatch
ScanEnd:
        bsf    ecx,ecx                      ;   Get the BYTE number for the first mismatch.
        lea    eax,[eax+ecx]                ;   Return the match character pointer.
NoMatch:
	    ret
KRBNew endp
KRBNew_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

KRBNew2 proc
        pop    ecx
        pop    ebx
        pop    eax
        push   ecx
        movdqa xmm2,OWORD PTR Src4          ;   16 nulls.
        or     bl,bl                        ;   Look for a null?
        jz     ScanNull                     ;   Yes, that simplifies things.
        mov    bh,bl                        ;   Build 16 copies of the search character.
        mov    cx,bx
        shl    ecx,16
        or     cx,bx
        mov    ebx,OFFSET Src5
        mov    [ebx],ecx
        mov    [ebx+4],ecx
        mov    [ebx+8],ecx
        mov    [ebx+12],ecx
        movdqa xmm1,[ebx]                   ;   16 copies of the search character.
ScanChar:
        movdqu xmm0,[eax]                   ;   The last 16 BYTES of the buffer will be reserved so
                                            ;    that this MOV will not fail on a short last record.
        movdqa xmm3,xmm0                    ;   Copy.
        pcmpeqb xmm0,xmm1                   ;   1's replace xmm0 characters that match xmm1 characters.
        pmovmskb ecx,xmm0                   ;   Extract comparison bits - 1's for characters that matched.
        mov    edx,-1                       ;   Preset no match = max uint.
        or     ecx,ecx                      ;   Any match?
        jz     LookNull                     ;   No, use preset.
        bsf    edx,ecx                      ;   Get the BYTE number 0-15.
LookNull:
        pcmpeqb xmm3,xmm2                   ;   1's replace xmm0 characters that match xmm2 characters.
        pmovmskb ebx,xmm3                   ;   Extract comparison bits - 1's for characters that matched.
        or     ecx,ebx                      ;   Use whichever is found first or earlier.
        lea    eax,[eax+16]                 ;   Point to next 16 bytes.
        jz     ScanChar                     ;   Nothing found yet.
;
;   Character or the null or both were found.
;
        or     ebx,ebx                      ;   Was a null found?
        jz     ScanEnd                      ;   No, then edx is already correct for the found character.
        bsf    ebx,ebx                      ;   Get the character number for the null 0-15.
        cmp    edx,ebx
        cmova  edx,ebx                      ;   A found null and a no match character = use null.
        cmp    ebx,edx                      ;   Is the returned position for the character, not the null?
        jnz    ScanEnd                      ;   Yes, return its position (in edx).
        xor    eax,eax                      ;   Set the return for no match.
        jmp    ScanExit
ScanNull:
        movdqu xmm3,[eax]                   ;   The last 16 BYTES of the buffer will be reserved so
                                            ;    that this MOV will not fail on a short last record.
        pcmpeqb xmm3,xmm2                   ;   1's replace xmm0 characters that match xmm2 characters.
        pmovmskb edx,xmm3                   ;   Extract comparison bits - 1's for characters that matched.
        test   edx,0FFFFh                   ;   Any character a null?
        lea    eax,[eax+16]                 ;   Point to next 16 bytes.
        jz     ScanNull                     ;   No, null not found yet.
        bsf    edx,edx                      ;   Get the BYTE number for the first null match.
ScanEnd:
        lea    eax,[eax+edx-16]             ;   Return the match character pointer.
ScanExit:
	    ret
KRBNew2 endp
KRBNew2_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

KRBNew3 proc
        pop    ecx
        pop    ebx
        pop    eax
        push   ecx
        movdqa xmm2,OWORD PTR Src4          ;   16 nulls.
        or     bl,bl                        ;   Look for a null?
        jz     ScanEOL                      ;   Yes, that simplifies things.
        mov    bh,bl                        ;   Build 16 copies of the search character.
        mov    cx,bx
        shl    ecx,16
        or     cx,bx
        mov    ebx,OFFSET Src5
        mov    [ebx],ecx
        mov    [ebx+4],ecx
        mov    [ebx+8],ecx
        mov    [ebx+12],ecx
        movdqa xmm1,[ebx]                   ;   Get 16 copies of the search character.
ScanChar:
        movdqu xmm0,[eax]                   ;   The last 16 BYTES of the buffer will be reserved so
                                            ;    that this MOV will not fail on a short last record.
        movdqa xmm3,xmm0                    ;   Copy.
        pcmpeqb xmm0,xmm1                   ;   1's replace xmm0 characters that match xmm1 characters.
        pmovmskb ecx,xmm0                   ;   Extract comparison bits - 1's for characters that matched.
        mov    edx,-1                       ;   Preset no match = max uint.
        or     ecx,ecx                      ;   Any match?
        jz     ScanNull                     ;   No, use preset.
        bsf    edx,ecx                      ;   Get the BYTE number 0-15.
ScanNull:
        pcmpeqb xmm3,xmm2                   ;   1's replace xmm0 characters that match xmm2 characters.
        pmovmskb ebx,xmm3                   ;   Extract comparison bits - 1's for characters that matched.
        or     ecx,ebx                      ;   Use whichever is found first or earlier.
        lea    eax,[eax+16]                 ;   Point to next 16 bytes.
        jz     AlignChar                    ;   Nothing found yet.
;
;   Character or the null or both were found.
;
FoundSomething:
        or     ebx,ebx                      ;   Was a null found?
        jz     ScanEnd                      ;   No, then edx is already correct for the found character.
        bsf    ebx,ebx                      ;   Get the character number for the null 0-15.
        cmp    edx,ebx
        cmova  edx,ebx                      ;   A found null and a no match character = use null.
        cmp    ebx,edx                      ;   Is the returned position for the character, not the null?
        jnz    ScanEnd                      ;   Yes, return its position (in edx).
        xor    eax,eax                      
        jmp    ScanExit                     ;   No, return a null.
AlignChar:
        and    eax,-16                      ;   Align to mod 16 boundary.
LoopChar:
        movdqa xmm0,[eax]                   ;   The last 16 BYTES of the buffer will be reserved so
                                            ;    that this MOV will not fail on a short last record.
        movdqa xmm3,xmm0                    ;   Copy.
        pcmpeqb xmm0,xmm1                   ;   1's replace xmm0 characters that match xmm1 characters.
        pmovmskb ecx,xmm0                   ;   Extract comparison bits - 1's for characters that matched.
        mov    edx,-1                       ;   Preset no match = max uint.
        or     ecx,ecx                      ;   Any match?
        jz     LookNull                     ;   No, use preset.
        bsf    edx,ecx                      ;   Get the BYTE number 0-15.
LookNull:
        pcmpeqb xmm3,xmm2                   ;   1's replace xmm0 characters that match xmm2 characters.
        pmovmskb ebx,xmm3                   ;   Extract comparison bits - 1's for characters that matched.
        or     ecx,ebx                      ;   Use whichever is found first or earlier.
        lea    eax,[eax+16]                 ;   Point to next 16 bytes.
        jz     LoopChar                     ;   Nothing found yet.
        jmp    FoundSomething
ScanEOL:
        movdqu xmm3,[eax]                   ;   The last 16 BYTES of the buffer will be reserved so
                                            ;    that this MOV will not fail on a short last record.
        pcmpeqb xmm3,xmm2                   ;   1's replace xmm0 characters that match xmm2 characters.
        pmovmskb edx,xmm3                   ;   Extract comparison bits - 1's for characters that matched.
        test   edx,0FFFFh                   ;   Any character a null?
        lea    eax,[eax+16]                 ;   Point to next 16 bytes.
        jnz    ReturnEOL                    ;   Yes, return the end of the line.
        and    eax,-16                      ;   Align to mod 16 boundary.
LoopEOL:
        movdqa xmm3,[eax]                   ;   The last 16 BYTES of the buffer will be reserved so
                                            ;    that this MOV will not fail on a short last record.
        pcmpeqb xmm3,xmm2                   ;   1's replace xmm0 characters that match xmm2 characters.
        pmovmskb edx,xmm3                   ;   Extract comparison bits - 1's for characters that matched.
        test   edx,0FFFFh                   ;   Any character a null?
        lea    eax,[eax+16]                 ;   Point to next 16 bytes.
        jz     LoopEOL                      ;   No, null not found yet.
ReturnEOL:
        bsf    edx,edx                      ;   Get the BYTE number for the first null match.
ScanEnd:
        lea    eax,[eax+edx-16]             ;   Return the match character pointer.
ScanExit:
	    ret
KRBNew3 endp
KRBNew3_endp:

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start

RichMasm options:

OPT_Tmp2Asm	1
OPT_Wait	0
OPT_Olly	2
OxPT_DebugA	/Zi	; activate symbols
OPT_Assembler	mlv615	; must be present in \bin
OxPT_DebugL	/debug /debugtype:cv	; for debugging
OxPT_Linker	linkv614	; must be present in \bin

[CPU]
Placement=0,0,392,515,3	; shows 3 xmm regs

[url=http://stackoverflow.com/questions/1128096/c-string-comparison-in-one-clock-cycle]@Paul:[/url]
The GLIBC strcmp() implementation is the naive one: read successive bytes until they differ.
Compiled with gcc-4 -O2, it uses the pcmpeqb and pmovmskb instructions.
I don't see how it could be any more efficient.  greyfade Jul 15 at 3:46

[url=http://www.strchr.com/strcmp_and_strlen_using_sse_4.2]SSE4:[/url]
SSE 4.2 introduces four instructions (PcmpEstrI, PcmpEstrM, PcmpIstrI, and PcmpIstrM) that can be used to
speed up text processing code (including strcmp, memcmp, strstr, and strspn functions)

	MovDqU xmm0, dqword[str1]
	PcmpIstrI xmm0, dqword[str2], imm

Equal each (imm[3:2] = 10). This operation compares two strings

	operand1 = "UseFlatAssembler"
	operand2 = "UsingAnAssembler"
	IntRes1  =  1100000111111111

For Instr_(:
Equal ordered (imm[3:2] = 11). Substring search (strstr). The first operand contains a string to search for,
the second is a string to search in. The bit mask includes 1 if the substring is found at the corresponding position:

	operand2 = "WhenWeWillBeWed!"
	operand1 = "We"
	IntRes1  =  000010000000100
